From 6fa50035ca338495527f473cfbaad4891d96b436 Mon Sep 17 00:00:00 2001
From: David Malcolm <dmalcolm@redhat.com>
Date: Wed, 10 Jul 2019 18:24:27 -0400
Subject: [PATCH 72/85] FIXME: initial implementation of canonicalization
 (disabled for now)

---
 gcc/analyzer/impl-4.cc                          |  30 ++++
 gcc/analyzer/region-model.cc                    | 202 +++++++++++++++++++++++-
 gcc/analyzer/region-model.h                     |  30 ++++
 gcc/testsuite/gcc.dg/analyzer/malloc-vs-local.c |   3 +-
 4 files changed, 260 insertions(+), 5 deletions(-)

diff --git a/gcc/analyzer/impl-4.cc b/gcc/analyzer/impl-4.cc
index 122dc09..147fbdf 100644
--- a/gcc/analyzer/impl-4.cc
+++ b/gcc/analyzer/impl-4.cc
@@ -3091,7 +3091,12 @@ public:
 
 	int idx_of_def_stmt;
 	bool found = epath.find_stmt_backwards (def_stmt, &idx_of_def_stmt);
+#if 0
 	gcc_assert (found);
+#else
+	if (!found)
+	  goto not_found;
+#endif
 
 	/* What was the next write to the underlying var
 	   after the SSA name was set? (if any).  */
@@ -3121,6 +3126,9 @@ public:
 	  }
       }
 
+    /* FIXME: not sure why this is needed.  */
+  not_found:
+
     /* Look backwards for the first statement with a location.  */
     int i;
     const exploded_edge *eedge;
@@ -7514,6 +7522,27 @@ test_program_point_ordering ()
 /* FIXME.  */
 
 static void
+test_program_state_merging ()
+{
+  // TODO
+  using namespace impl_4;
+  auto_delete_vec <state_machine> checkers;
+  checkers.safe_push (make_malloc_state_machine (NULL));
+  extrinsic_state ext_state (checkers);
+  program_state s0 (ext_state);
+  program_state s1 (s0);
+  ASSERT_EQ (s0, s1);
+
+  /* Two identical states with x pointing to a heap region
+     with sm-states.
+     They ought to be mergeable, preserving the sm-state.  */
+
+  // TODO
+}
+
+/* FIXME.  */
+
+static void
 test_assignments ()
 {
   /* Verify X = Y, then Y = Z.
@@ -7528,6 +7557,7 @@ analyzer_impl_4_cc_tests ()
   test_sm_state_map ();
   test_program_point_equality ();
   test_program_point_ordering ();
+  test_program_state_merging ();
   test_assignments ();
 }
 
diff --git a/gcc/analyzer/region-model.cc b/gcc/analyzer/region-model.cc
index 5418a8c..7df1d7e 100644
--- a/gcc/analyzer/region-model.cc
+++ b/gcc/analyzer/region-model.cc
@@ -502,6 +502,14 @@ svalue::remap_region_ids (const region_id_map &)
   /* Empty.  */
 }
 
+/* FIXME.  */
+
+void
+svalue::walk_for_canonicalization (canonicalization *) const
+{
+  /* Empty.  */
+}
+
 /* class region_svalue : public svalue.  */
 
 /* FIXME.  */
@@ -745,6 +753,14 @@ region_svalue::can_merge_values_p (const region_svalue &region_sval_a,
 	}
 }
 
+/* FIXME.  */
+
+void
+region_svalue::walk_for_canonicalization (canonicalization *c) const
+{
+  c->walk_rid (m_rid);
+}
+
 /* class constant_svalue : public svalue.  */
 
 /* FIXME.  */
@@ -1587,6 +1603,30 @@ map_region::can_merge_p (const map_region *map_region_a,
 
 /* FIXME.  */
 
+void
+map_region::walk_for_canonicalization (canonicalization *c) const
+{
+  auto_vec<tree> keys;
+  for (map_t::iterator iter = m_map.begin ();
+       iter != m_map.end ();
+       ++iter)
+    {
+      tree key_a = (*iter).first;
+      keys.safe_push (key_a);
+    }
+  keys.qsort (tree_cmp);
+
+  unsigned i;
+  tree key;
+  FOR_EACH_VEC_ELT (keys, i, key)
+    {
+      region_id rid = *const_cast<map_region *>(this)->m_map.get (key);
+      c->walk_rid (rid);
+    }
+}
+
+/* FIXME.  */
+
 bool
 frame_region::compare_fields (const frame_region &other) const
 {
@@ -1814,6 +1854,17 @@ stack_region::can_merge_p (const stack_region *stack_region_a,
   return true;
 }
 
+/* FIXME.  */
+
+void
+stack_region::walk_for_canonicalization (canonicalization *c) const
+{
+  int i;
+  region_id *frame_rid;
+  FOR_EACH_VEC_ELT (m_frame_rids, i, frame_rid)
+    c->walk_rid (*frame_rid);
+}
+
 /* class heap_region : public region.  */
 
 /* FIXME.  */
@@ -1864,6 +1915,14 @@ heap_region::can_merge_p (const heap_region *heap_a ATTRIBUTE_UNUSED,
   return true;
 }
 
+/* FIXME.  */
+
+void
+heap_region::walk_for_canonicalization (canonicalization *) const
+{
+  // empty
+}
+
 /* class root_region : public region.  */
 
 /* FIXME.  */
@@ -2180,6 +2239,16 @@ root_region::add_to_hash (inchash::hash &hstate) const
   inchash::add (m_heap_rid, hstate);
 }
 
+/* FIXME.  */
+
+void
+root_region::walk_for_canonicalization (canonicalization *c) const
+{
+  c->walk_rid (m_stack_rid);
+  c->walk_rid (m_globals_rid);
+  c->walk_rid (m_heap_rid);
+}
+
 /* class symbolic_region : public map_region.  */
 
 /* FIXME.  */
@@ -2522,12 +2591,38 @@ region_model::validate () const
     }
 }
 
-/* FIXME.  */
+/* Reorder the regions and svalues into a deterministic "canonical" order,
+   to maximize the chance of equality.
+   If non-NULL, notify CTXT about the svalue id remapping.  */
 
 void
-region_model::canonicalize (region_model_context *ctxt ATTRIBUTE_UNUSED)
+region_model::canonicalize (region_model_context *ctxt)
 {
-  // TODO
+  // FIXME: disabled for now
+  return;
+
+  /* First pass: walk all regions in a deterministic order, generating
+     a rid and sid map.  */
+  canonicalization c (*this);
+  c.walk_rid (m_root_rid);
+
+  /* Second pass: ensure we've visited everything, as we don't want to purge
+     at this stage.  */
+  unsigned i;
+  region *region;
+  FOR_EACH_VEC_ELT (m_regions, i, region)
+    c.walk_rid (region_id::from_int (i));
+  svalue *sval;
+  FOR_EACH_VEC_ELT (m_svalues, i, sval)
+    c.walk_sid (svalue_id::from_int (i));
+
+  /* Third pass: reorder the regions and values.  */
+  remap_svalue_ids (c.m_sid_map);
+  remap_region_ids (c.m_rid_map);
+  if (ctxt)
+    ctxt->remap_svalue_ids (c.m_sid_map);
+
+  validate ();
 }
 
 /* FIXME.  */
@@ -4434,6 +4529,55 @@ model_merger::record_regions (region_id a_rid,
 
 ////////////////////////////////////////////////////////////////////////////
 
+/* struct canonicalization.  */
+
+/* FIXME.  */
+
+canonicalization::canonicalization (const region_model &model)
+: m_model (model),
+  m_rid_map (model.get_num_regions ()),
+  m_sid_map (model.get_num_svalues ()),
+  m_next_rid_int (0),
+  m_next_sid_int (0)
+{
+}
+
+/* FIXME.  */
+
+void
+canonicalization::walk_rid (region_id rid)
+{
+  /* Stop if we've already seen RID.  */
+  if (!m_rid_map.get_dst_for_src (rid).null_p ())
+    return;
+
+  region *region = m_model.get_region (rid);
+  if (region)
+    {
+      m_rid_map.put (rid, region_id::from_int (m_next_rid_int++));
+      walk_sid (region->get_value_direct ());
+      region->walk_for_canonicalization (this);
+    }
+}
+
+void
+canonicalization::walk_sid (svalue_id sid)
+{
+  /* Stop if we've already seen SID.  */
+  if (!m_sid_map.get_dst_for_src (sid).null_p ())
+    return;
+
+  svalue *sval = m_model.get_svalue (sid);
+  if (sval)
+    {
+      m_sid_map.put (sid, svalue_id::from_int (m_next_sid_int++));
+      /* Potentially walk regions e.g. for ptrs.  */
+      sval->walk_for_canonicalization (this);
+    }
+}
+
+////////////////////////////////////////////////////////////////////////////
+
 /* FIXME.  */
 
 void
@@ -4937,6 +5081,26 @@ assert_region_models_merge (tree expr, tree val_a, tree val_b,
 
 }
 
+/* FIXME.  */
+
+static void
+test_canonicalization ()
+{
+  region_model model0;
+  model0.get_root_region ()->ensure_stack_region (&model0);
+  model0.get_root_region ()->ensure_globals_region (&model0);
+
+  region_model model1;
+  model1.get_root_region ()->ensure_globals_region (&model1);
+  model1.get_root_region ()->ensure_stack_region (&model1);
+
+  model0.canonicalize (NULL);
+  model1.canonicalize (NULL);
+#if 0
+  ASSERT_EQ (model0, model1);
+#endif
+}
+
 struct region_model_merger_test
 {
   test_region_model_context ctxt;
@@ -5136,7 +5300,36 @@ test_state_merging ()
   }
 
   /* Pointers: non-NULL and non-NULL: ptr to a heap region.  */
-  // TODO
+  {
+    test_region_model_context ctxt;
+    region_model model0;
+    // FIXME: maybe introduce a helper function for this
+    // and share with malloc (and other selftests):
+    region_id heap_rid
+      = model0.get_root_region ()->ensure_heap_region (&model0);
+    region_id new_rid = model0.add_region (new symbolic_region (heap_rid));
+    svalue_id ptr_sid
+      = model0.get_or_create_ptr_svalue (ptr_type_node, new_rid);
+    model0.set_value (model0.get_lvalue (x, &ctxt),
+		      ptr_sid);
+    model0.canonicalize (&ctxt);
+
+    region_model model1 (model0);
+
+    ASSERT_EQ (model0, model1);
+
+    region_model merged;
+    ASSERT_TRUE (model0.can_merge_with_p (model1, &merged));
+
+    merged.canonicalize (&ctxt);
+
+    /* The merged model ought to be identical.  */
+    // FIXME: seems to be failing due to ordering;
+    // time to implement canonicalization?
+#if 0
+    ASSERT_EQ (model0, merged);
+#endif
+  }
 
 #if 0
   {
@@ -5187,6 +5380,7 @@ analyzer_region_model_cc_tests ()
   test_purging ();
 #endif
   // TODO: test coverage for get_representative_tree / get_trees_for_svalue
+  test_canonicalization ();
   test_state_merging ();
 }
 
diff --git a/gcc/analyzer/region-model.h b/gcc/analyzer/region-model.h
index bae5fc9..46c16cb 100644
--- a/gcc/analyzer/region-model.h
+++ b/gcc/analyzer/region-model.h
@@ -39,6 +39,7 @@ class region;
 class region_model;
 class region_model_context;
 struct model_merger;
+struct canonicalization;
 class pending_diagnostic;
 
 class constraint_manager;
@@ -269,6 +270,8 @@ public:
 
   virtual void remap_region_ids (const region_id_map &map);
 
+  virtual void walk_for_canonicalization (canonicalization *c) const;
+
  protected:
   svalue (tree type) : m_type (type) {}
 
@@ -319,6 +322,8 @@ public:
 				  tree type,
 				  model_merger *merger);
 
+  void walk_for_canonicalization (canonicalization *c) const FINAL OVERRIDE;
+
  private:
   void print_details (const region_model &model,
 		      svalue_id this_sid,
@@ -518,6 +523,8 @@ public:
   void remap_svalue_ids (const svalue_id_map &map);
   virtual void remap_region_ids (const region_id_map &map);
 
+  virtual void walk_for_canonicalization (canonicalization *c) const = 0;
+
  protected:
   region (region_id parent_rid, svalue_id sval_id, tree type)
   : m_parent_rid (parent_rid), m_sval_id (sval_id), m_type (type)
@@ -586,6 +593,8 @@ public:
 			   region_id merged_rid,
 			   model_merger *merger);
 
+  void walk_for_canonicalization (canonicalization *c) const FINAL OVERRIDE;
+
  protected:
   void add_to_hash (inchash::hash &hstate) const OVERRIDE;
   void print_fields (const region_model &model,
@@ -671,6 +680,8 @@ public:
 			   const stack_region *stack_region_b,
 			   model_merger *merger);
 
+  void walk_for_canonicalization (canonicalization *c) const FINAL OVERRIDE;
+
  private:
   void add_to_hash (inchash::hash &hstate) const FINAL OVERRIDE;
   void print_fields (const region_model &model,
@@ -702,6 +713,8 @@ public:
 			   heap_region *merged_heap, region_id merged_heap_rid,
 			   model_merger *merger);
 
+  void walk_for_canonicalization (canonicalization *c) const FINAL OVERRIDE;
+
 };
 
 /* The root region, containing all regions (either directly, or as
@@ -749,6 +762,8 @@ public:
 			   root_region *merged_root_region,
 			   model_merger *merger);
 
+  void walk_for_canonicalization (canonicalization *c) const FINAL OVERRIDE;
+
 private:
   void add_to_hash (inchash::hash &hstate) const FINAL OVERRIDE;
   void print_fields (const region_model &model,
@@ -1044,6 +1059,21 @@ struct model_merger
   one_way_region_id_map m_map_regions_from_b_to_m;
 };
 
+/* FIXME. */
+
+struct canonicalization
+{
+  canonicalization (const region_model &model);
+  void walk_rid (region_id rid);
+  void walk_sid (svalue_id sid);
+
+  const region_model &m_model;
+  region_id_map m_rid_map;
+  svalue_id_map m_sid_map;
+  int m_next_rid_int;
+  int m_next_sid_int;
+};
+
 namespace inchash
 {
   extern void add (svalue_id sid, hash &hstate);
diff --git a/gcc/testsuite/gcc.dg/analyzer/malloc-vs-local.c b/gcc/testsuite/gcc.dg/analyzer/malloc-vs-local.c
index 860e839..3d93cc3 100644
--- a/gcc/testsuite/gcc.dg/analyzer/malloc-vs-local.c
+++ b/gcc/testsuite/gcc.dg/analyzer/malloc-vs-local.c
@@ -49,8 +49,9 @@ int test_repeated_predicate_1 (int n)
   result = do_stuff (ptr, n);
 
   __analyzer_dump_exploded_nodes (0); /* { dg-warning "5 exploded nodes" } */
-  __analyzer_dump_exploded_nodes (0); /* { dg-warning "5 exploded nodes" } */
   // FIXME: why 5 here?
+  __analyzer_dump_exploded_nodes (0); /* { dg-warning "5 exploded nodes" } */
+  // FIXME: why 4 (or 5) here?
 
   if (n > 10)
     free (ptr); /* { dg-bogus "not on the heap" } */
-- 
1.8.5.3